import { RequestMethod } from "../../enums/RequestMethod";
import { IConnection, ISavepoint } from "type-interface";
import { AxiosOption } from "./AxiosOption";
/**
 *
 * 功能描述:
 *
 * @className RestConnection
 * @projectName papio
 * @author yanshaowen
 * @date 2019/2/1 13:32
 */
export declare class AxiosConnection implements IConnection {
    kind: "IConnection";
    readonly options: AxiosOption;
    private readonlyConnection;
    constructor(options: AxiosOption);
    close(): Promise<void>;
    commit(savePoint: ISavepoint): Promise<void>;
    connect(): Promise<void>;
    isClosed(): boolean;
    isConnected(): boolean;
    isReadOnly(): boolean;
    rollback(savePoint: ISavepoint): Promise<void>;
    setReadOnly(readOnly: boolean): void;
    setSavepoint(name?: string): ISavepoint;
    startTransaction(level?: any): Promise<ISavepoint>;
    request<T>(result: new () => T, genericsProperty: Map<string, new () => object>, uri: string): Promise<T>;
    request<T>(result: new () => T, genericsProperty: Map<string, new () => object>, uri: string, method: RequestMethod): Promise<T>;
    request<T>(result: new () => T, genericsProperty: Map<string, new () => object>, uri: string, method: RequestMethod, timeout: number): Promise<T>;
    request<T>(result: new () => T, genericsProperty: Map<string, new () => object>, uri: string, method: RequestMethod, timeout: number, params: object): Promise<T>;
    request<T>(result: new () => T, genericsProperty: Map<string, new () => object>, uri: string, method: RequestMethod, timeout: number, params: object, body: object): Promise<T>;
    request<T>(result: new () => T, genericsProperty: Map<string, new () => object>, uri: string, method: RequestMethod, timeout: number, params: object, body: object, headers: object): Promise<T>;
    static build(options: AxiosOption, isReadOnly: boolean): Promise<AxiosConnection>;
}
