"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Agent = require("agentkeepalive");
const AxiosConnection_1 = require("./AxiosConnection");
/**
 *
 * 功能描述: http and http dataSource
 *
 * @className RestDataSource
 * @projectName papio
 * @author yanshaowen
 * @date 2019/2/1 13:08
 */
class AxiosDataSource {
    constructor() {
        this.kind = "IDataSource";
        this.url = "http://localhost:3001";
        this.readonlyConnection = false;
    }
    build() {
        const op = {};
        op.url = this.url;
        op.username = this.username;
        op.password = this.password;
        op.name = this.name;
        if (this.agentConfig) {
            op.agent = new Agent(this.agentConfig);
        }
        this.buildOption = op;
    }
    async getConnection(username, password) {
        if (this.httpConnection) {
            return this.httpConnection;
        }
        this.httpConnection = await AxiosConnection_1.AxiosConnection.build(this.buildOption, this.isReadOnly());
        return this.httpConnection;
    }
    getLogWriter() {
        return this.logWriter;
    }
    getLoginTimeout() {
        return this.loginTimeout;
    }
    setLogWriter(printWrite) {
        this.logWriter = printWrite;
    }
    setLoginTimeout(seconds) {
        this.loginTimeout = seconds;
    }
    getAgentConfig() {
        return this.agentConfig;
    }
    setAgentConfig(agentConfig) {
        this.agentConfig = agentConfig;
    }
    getUsername() {
        return this.username;
    }
    setUsername(username) {
        this.username = username;
    }
    getPassword() {
        return this.password;
    }
    setPassword(password) {
        this.password = password;
    }
    getName() {
        return this.name;
    }
    setName(name) {
        this.name = name;
    }
    isReadOnly() {
        return this.readonlyConnection;
    }
    setReadOnly(readOnly) {
        this.readonlyConnection = readOnly;
    }
    getUrl() {
        return this.url;
    }
    setUrl(url) {
        this.url = url;
    }
}
exports.AxiosDataSource = AxiosDataSource;
//# sourceMappingURL=AxiosDataSource.js.map